Team 1 Playlist Generator/PG.Web/Controllers/PlaylistsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;
using Microsoft.AspNetCore.Mvc;
using PagedList;
using PG.Models;
using PG.Services.Contract;
using PG.Services.DTOs;
using PG.Web.Models;
using PG.Web.Models.Mappers;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace PG.Web.Controllers
{
    [Authorize]
    public class PlaylistsController : Controller
    {
        private readonly IPlaylistService _playlistService;
        private readonly IGenreService _genreService;
        private readonly IBingMapsAPIService _bingMapsAPIService;
        private readonly UserManager<User> _userManager;

        public PlaylistsController(IPlaylistService playlistService, IGenreService genreService, IBingMapsAPIService bingMapsAPIService,
            UserManager<User> userManager)
        {
            _playlistService = playlistService;
            _genreService = genreService;
            _bingMapsAPIService = bingMapsAPIService;
            _userManager = userManager;
        }

        [AllowAnonymous]
        public async Task<IActionResult> Index(string searchQuery = "", string genre = "", string duration = "")
        {
            IEnumerable<PlaylistDTO> playlistsDTOs = await _playlistService.GetAllPlaylistsWithSettings(searchQuery, genre, duration);
            IList<PlaylistViewModel> playlistsViewModels = playlistsDTOs.Select(x => x.ToViewModel()).ToList();

            var allGenres = await _genreService.GetAllGenres();

            var genresAndDefault = new List<string>();
            genresAndDefault.AddRange(allGenres.Select(x => x.Name));
            ViewBag.Genres = genresAndDefault;

            ViewBag.MaxPlaylistDuration = _playlistService.GetMaxPlaylistDuration(playlistsDTOs);

            return View(playlistsViewModels);
        }

        public IActionResult Create()
        {
            return View();
        }

        [HttpPost]
        public async Task<int> Create(string startLocation, string endLocation, string playlistName, int metal, int rock, int pop, int chalga, bool topTracks, bool sameArtist)
        {

            int tripTime = await _bingMapsAPIService.FindDuration(startLocation, endLocation);
            var user = await _userManager.GetUserAsync(User);

            var playlistId = await _playlistService.GeneratePlaylist(tripTime, playlistName, metal, rock, pop, chalga, topTracks, sameArtist, user);

            return playlistId;
        }

        public async Task<IActionResult> Edit(int id)
        {
            var playlist = await _playlistService.GetPlaylistById(id);

            return View(playlist.ToViewModel());
        }

        [HttpPost]
        public async Task<IActionResult> Edit(string playlistId, string playlistTitle, string playlistPixabayImage)
        {
            var playlist = await _playlistService.Update(int.Parse(playlistId), playlistTitle, playlistPixabayImage);

            return View(playlist.ToViewModel());
        }


        [AllowAnonymous]
        public async Task<IActionResult> Details(int id, int pageNumber = 1)
        {
            PlaylistDTO playlistDTO = await _playlistService.GetPlaylistById(id);
            PlaylistViewModel playlistViewModel = playlistDTO.ToViewModel();

            playlistViewModel.SongsPaged = playlistViewModel.Songs.ToPagedList(pageNumber, 13);

            ViewBag.ShowEdit = _userManager.GetUserId(User) == playlistViewModel.UserId || User.IsInRole("Admin");

            return View(playlistViewModel);
        }

        public async Task<IActionResult> MyPlaylists()
        {

            IEnumerable<PlaylistDTO> playlistsDTOs = await _playlistService.GetPlaylistsByUser(_userManager.GetUserId(User));
            IList<PlaylistViewModel> playlistsViewModels = playlistsDTOs.Select(x => x.ToViewModel()).ToList();

            return View(playlistsViewModels);
        }



        [HttpPost]
        public async Task<bool> DeletePlaylist(int id)
        {
            await _playlistService.Delete(id);

            return true;
        }

        [HttpPost]
        public async Task<IActionResult> UpdateAccess(int playlistId)
        {
            await _playlistService.UpdatePublicAccess(playlistId);

            var playlist = await _playlistService.GetPlaylistById(playlistId);

            return View("Edit", playlist.ToViewModel());
        }



    }
}

Team 1 Playlist Generator/PG.Web/Views/Shared/_DisplayPlaylistsPartial.cshtml
@model IList<PlaylistViewModel>


@if (Model.Any())
{
    <div class="playlists">
        @foreach (var item in Model)
        {
            <div>
                <a asp-controller="Playlists" asp-action="Details" asp-route-id="@item.Id">
                    <p>@item.Title</p>
                    <img src="https://cdn.pixabay.com/photo/2021/10/23/03/35/mountain-6734031_960_720.jpg" class="playlistImage"> @*@item.PixabayImage*@
                    <p>Duration: @item.DurationInHours</p>
                    <p>Rank: @item.Rank</p>
                </a>
            </div>
        }
    </div>
}
else
{
<h2>Sorry, there are no playlists avaliable</h2>
}

Team 1 Playlist Generator/PG.Web/Views/Shared/_Footer.cshtml
<footer id="footer">
    <div>
        <p>&copy; 2020 by Team1. All rights reserved.</p>
        <ul>
            <li>
                <a href="" id="twitter">Twitter</a>
            </li>
            <li>
                <a href="" id="facebook">Facebook</a>
            </li>
            <li>
                <a href="" id="googleplus">Googleplus</a>
            </li>
            <li>
                <a href="" id="pinterest">Pinterest</a>
            </li>
        </ul>
    </div>
</footer>

Team 1 Playlist Generator/PG.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - PG.Web</title>

    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css" integrity="sha384-ggOyR0iXCbMQv3Xipma34MD+dH/1fQ784/j6cY/iJTQUOhcWr7x9JvoRxT2MZw1T" crossorigin="anonymous">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.js"></script>


    <script src="https://cdns-files.dzcdn.net/js/min/dz-v00401311.js" type="text/javascript"></script>


    <link href="~/css/Shared/style.css" rel="stylesheet" />
    <link href="~/css/Shared/Navbar.css" rel="stylesheet" />
    <link href="~/css/Shared/Footer.css" rel="stylesheet" />

    @RenderSection("Scripts", false)

</head>
<body>
    <partial name="_NavBarPartial" />

    <main role="main" class="pb-3 main">
        @RenderBody()
    </main>

    <partial name="_Footer" />

</body>

</html>

Team 1 Playlist Generator/PG.Web/Views/Shared/_NavBarPartial.cshtml
<div id="header">
    <a asp-controller="Home" asp-action="Index" class="logo">
        <img src="@Url.Content("~/images/logo.jpg")" alt="">
    </a>

    <ul id="navigation">
        <li class="selected">
            <a class="nav-link" asp-controller="Home" asp-action="Index">Home <span class="sr-only">(current)</span></a>
        </li>
        <li>
            <a class="nav-link" asp-controller="Playlists" asp-action="Index">Playlists</a>
        </li>
        @if (User.Identity.IsAuthenticated)
        {
            <li class="nav-item">
                <a class="nav-link" asp-controller="Playlists" asp-action="MyPlaylists">My Playlists</a>
            </li>
            <li class="nav-item">
                <a class="nav-link" asp-controller="Playlists" asp-action="Create">Create Playlist</a>
            </li>
        }
        else
        {
            <li class="nav-item">
                <a class="nav-link" id="login" asp-area="Identity" asp-page="/Account/Login">Create Playlist</a>
            </li>
        }

        @if (User.IsInRole("Admin"))
        {
            <li class="nav-item">
                <a class="nav-link" asp-controller="Admin" asp-action="Users">Users</a>
            </li>
        }

        <partial name="_LoginPartial" />
    </ul>
</div>